function CHero(iX,iY){
    var _bIdle;
    var _iStartingX;
    var _iStartingY;
    var _iSpeedDown;
    var _iHalfHeight;
    var _oSprite;
    
    this._init = function(iX,iY){
        _iSpeedDown = 0;
        _bIdle = true;
        
        var oSprite = s_oSpriteLibrary.getSprite('hero');
        var oData = {   // image to use
			framerate : 8,
                        images: [oSprite], 
                        // width, height & registration point of each sprite
                        frames: {width: 115, height: 82, regX: 57, regY: 41},
                        animations: {   jump:[0,1],idle: [1, 4],hurt:[4,8,"loop_hurt"],loop_hurt:[5,8] }
                        
        };
		
	var oSpriteObj = new createjs.SpriteSheet(oData);
        _oSprite = createSprite(oSpriteObj, "idle",57,41,115,82);

        _oSprite.x = _iStartingX = iX;
        _oSprite.y = _iStartingY = iY;
        s_oStage.addChild(_oSprite);
        
        _iHalfHeight = oSprite.height/2;
        
        this.idle(20);
    };
    
    this.unload = function(){
        s_oStage.removeChild(_oSprite);
    };
    
    this.reset = function(){
        _iSpeedDown = 0;
        _bIdle = true;
        
        _oSprite.x = _iStartingX;
        _oSprite.y = _iStartingY;
        
        _oSprite.gotoAndPlay("idle");
        this.idle(20);
    };
    
    this.idle = function(iMoveY){
        var oParent = this;
        createjs.Tween.get(_oSprite).to({y:_oSprite.y + iMoveY}, 450,createjs.Ease.cubicOut).call(function() { oParent.idle(iMoveY * -1) });
    };
    
    this.start = function(){
        createjs.Tween.removeTweens(_oSprite); 
        this.moveUp();
    };
    
    this.moveUp = function(){
        createjs.Tween.removeTweens(_oSprite);
        //createjs.Tween.get(_oSprite).to({rotation:_oSprite.rotation+90}, 450);
        _iSpeedDown = -HERO_DOWN_ACCELLERATION * 8;
        
        _oSprite.gotoAndStop("jump");
        _bIdle = false;
    };
    
    this.hurt = function(){
        _oSprite.gotoAndPlay("hurt");
    };
    
    this.getBottom = function(){
        return _oSprite.y + _iHalfHeight;
    };
    
    this.getX = function(){
        return _oSprite.x;
    };
    
    this.getY = function(){
        return _oSprite.y;
    };
    
    this.getRadius = function(){
        return _oSprite.width/2;
    };
    
    this.getSprite = function(){
        return _oSprite;
    };
    
    this.update = function(iFloorY){
        _iSpeedDown += HERO_DOWN_ACCELLERATION;
        
        if(_oSprite.y < -100){
            _oSprite.y = -100;
        }
        
        if(_iSpeedDown > 0 && _bIdle === false){
            _bIdle = true;
            _oSprite.gotoAndPlay("idle");
        }
        
        if( (_oSprite.y + _iHalfHeight +_iSpeedDown) > iFloorY ){
            //HERO IS FALLEN DOWN
            _oSprite.y = iFloorY - _iHalfHeight;
            
            s_oGame._gameOver();
        }else{
            _oSprite.y += _iSpeedDown;
        }
    };
    
    this._init(iX,iY);
}