function CInterface(){
    var _oButExit;
    var _oAudioToggle;
    var _oHitArea;
    var _oScoreTextBack;
    var _oScoreText;
    var _oHelpPanel;
    
    this._init = function(){
        var oParent = this;

	_oScoreTextBack = new createjs.Text(TEXT_SCORE +": 0","bold 42px chewyregular", "#000000"); 
        _oScoreTextBack.y = 42;
        s_oStage.addChild(_oScoreTextBack);
		
	_oScoreText = new createjs.Text(TEXT_SCORE +": 0","bold 42px chewyregular", "#fd82d9");
        _oScoreText.y = 40; 
        s_oStage.addChild(_oScoreText);
		
        _oScoreTextBack.x = (CANVAS_WIDTH/2) +2;
        _oScoreText.x = (CANVAS_WIDTH/2);
        _oScoreTextBack.textAlign = "center";
        _oScoreText.textAlign = "center";
              
        _oHelpPanel = new CHelpPanel(0,0,s_oSpriteLibrary.getSprite('bg_help'));
              
        _oHitArea = new createjs.Shape();
        _oHitArea.graphics.beginFill("white").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        _oHitArea.alpha = 0.01;
        s_oStage.addChild(_oHitArea);
        _oHitArea.on("pressup",function(){oParent._onTapScreen()});  
        
        var oSprite = s_oSpriteLibrary.getSprite('but_exit');
        _oButExit = new CGfxButton(CANVAS_WIDTH - (oSprite.width/2) -10,10+ (oSprite.height/2),oSprite,true);
        _oButExit.addEventListener(ON_MOUSE_UP, this._onExit, this);        
                
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){	
            _oAudioToggle = new CToggle(CANVAS_WIDTH - 140,10+ (oSprite.height/2),s_oSpriteLibrary.getSprite('audio_icon'),s_bAudioActive);
            _oAudioToggle.addEventListener(ON_MOUSE_UP, this._onAudioToggle, this);
        }
	
    };
    
    this.unload = function(){
        _oButExit.unload();
        _oButExit = null;
        
        s_oStage.removeChild(_oScoreTextBack);
        s_oStage.removeChild(_oScoreText);
        
	if(s_bMobile === false){
            _oAudioToggle.unload();
            _oAudioToggle = null;
        }
        
        var oParent = this;
        _oHitArea.off("pressup",function(){oParent._onTapScreen()}); 
        s_oStage.removeChild(_oHitArea);
        _oHelpPanel.unload();
    };

    this.refreshScore = function(iScore){
            _oScoreTextBack.text = TEXT_SCORE +": "+iScore;
            _oScoreText.text = TEXT_SCORE +": "+iScore;
    };
    
    this._onTapScreen = function(){
        _oHelpPanel.unload();
        s_oGame.tapScreen();
    };
    
    this._onExit = function(){
      s_oGame.onExit();  
    };

	
    this._onAudioToggle = function(){
        createjs.Sound.setMute(s_bAudioActive);
        s_bAudioActive = !s_bAudioActive;
    };
    
    this._init();
    
    return this;
}