ig.module(
	'game.entities.block'
).requires(
	'impact.entity',
	'plugins.touchcontrols'
).defines(function() {
	EntityBlock = TouchEntity.extend({
		gravityFactor: 0,
		size: {
			x: 38,
			y: 38
		},
		color: 0,
		hasBeenChecked: false,
		j: 0,
		i: 0,
		animSheet: new ig.AnimationSheet('media/acp_block1.png', 38, 38),
		init: function(x, y, settings) {
			this.parent(x, y, settings);
			this.addAnim('falling', 0.1, [0], true);
		},
		draw: function() {
			ig.system.context.save();
			this.parent();
			ig.system.context.restore();
		},
		pressed: function() {
			this.parent();
			ig.game.playGrid.checkAndExplodeBlocks(this);
		},
		kill: function() {
			this.parent();
			ig.game.spawnEntity(EntityDeadblock, this.pos.x, this.pos.y, {
				animSheet: this.animSheet
			});
		}
	});
	EntityOakblock = EntityBlock.extend({
		isGreen: true,
		color: 1,
		animSheet: new ig.AnimationSheet('media/acp_block1.png', 38, 38),
	});
	EntityFireblock = EntityBlock.extend({
		isRed: true,
		color: 2,
		animSheet: new ig.AnimationSheet('media/acp_block2.png', 38, 38)
	});
	EntityLightningblock = EntityBlock.extend({
		isBlue: true,
		color: 3,
		animSheet: new ig.AnimationSheet('media/acp_block3.png', 38, 38)
	});
	EntityDeadblock = ig.Entity.extend({
		gravityFactor: 3,
		collides: ig.Entity.COLLIDES.NEVER,
		omega: 0,
		lifetime: 1,
		lifetimer: null,
		size: {
			x: 38,
			y: 38
		},
		startAlpha: 0.5,
		maxVel: {
			x: 500,
			y: 500
		},
		init: function(x, y, settings) {
			this.parent(x, y, settings);
			this.addAnim('flying', 0.1, [0], true);
			this.omega = randomRange(-15, 15);
			this.currentAnim.alpha = this.startAlpha;
			this.lifetimer = new ig.Timer(this.lifetime);
			this.vel.x = randomRange(-200, 200);
			this.vel.y = randomRange(-50, -200);
		},
		update: function() {
			this.parent();
			this.currentAnim.angle += this.omega * ig.system.tick;
			this.currentAnim.alpha = this.lifetimer.delta().map(-this.lifetime, 0, 0.5, 0);
			if (this.lifetimer && this.lifetimer.delta() >= 0) {
				this.kill();
			}
		}
	})
});