ig.module(
	'game.entities.floatingtext'
).requires(
	'impact.entity',
	'impact.font'
).defines(function() {
	EntityFloatingtext = ig.Entity.extend({
		gravityFactor: 0,
		lifetime: 1,
		lifetimer: null,
		font: new ig.Font('media/boogaloo42.png'),
		collides: ig.Entity.COLLIDES.NEVER,
		string: "no string loaded",
		alpha: 1,
		init: function(x, y, settings) {
			this.parent(x, y, settings);
			this.lifetimer = new ig.Timer(this.lifetime);
			this.vel.y = -50;
		},
		update: function() {
			this.parent();
			this.alpha = this.lifetimer.delta().map(-this.lifetime, 0, 1, 0);
			if (this.lifetimer && this.lifetimer.delta() >= 0) {
				this.kill();
			}
		},
		draw: function() {
			ig.system.context.save();
			ig.system.context.globalAlpha = this.alpha;
			this.font.draw(this.string, this.pos.x, this.pos.y, ig.Font.ALIGN.CENTER);
			ig.system.context.restore();
		}
	});
});