ig.module(
	'game.entities.particles'
).requires(
	'impact.entity',
	'plugins.utilities'
).defines(function() {
	EntityParticle = ig.Entity.extend({
		gravityFactor: -1,
		maxVel: {
			x: 50,
			y: 50
		},
		animSheet: new ig.AnimationSheet('media/particles.png', 32, 32),
		omega: null,
		size: {
			x: 32,
			y: 32
		},
		lifeTime: null,
		lifeTimer: null,
		jitter: 5,
		init: function(x, y, settings) {
			this.parent(x, y, settings);
			this.omega = randomRange(-10, 10);
			this.lifeTime = randomRange(0.8, 1.3);
			this.addAnim('cherry', 0.1, [0], true);
			this.addAnim('citrus', 0.1, [1], true);
			if (Math.random() < 0.5) {
				this.currentAnim = this.anims.citrus;
			}
			this.currentAnim.angle = randomRange(0, 6);
			this.lifeTimer = new ig.Timer(this.lifeTime);
		},
		update: function() {
			this.parent();
			this.currentAnim.angle += this.omega * ig.system.tick;
			if (this.lifeTimer) {
				if (this.lifeTimer.delta() < 0) {
					this.currentAnim.alpha = this.lifeTimer.delta().map(-this.lifeTime, 0, 1, 0);
				} else if (this.lifeTimer.delta() >= 0) {
					this.kill();
				}
			}
		}
	});
});