ig.module(
	'game.entities.titlegraphic'
).requires(
	'impact.entity'
).defines(function() {
	EntityTitlegraphic = ig.Entity.extend({
		gravityFactor: 0,
		collides: ig.Entity.COLLIDES.NEVER,
		size: {
			x: 260,
			y: 200
		},
		starburstOffset: {
			x: 10,
			y: 35
		},
		animSheet: new ig.AnimationSheet('media/acp_title-text.png', 260, 240),
		starburstSheet: new ig.AnimationSheet('media/acp_starburst.png', 270, 270),
		starburstAnim: null,
		starburstOmega: 0.1,
		init: function(x, y, settings) {
			this.parent(x, y, settings);
			this.addAnim('menu', 0.1, [0], true);
			this.starburstAnim = new ig.Animation(this.starburstSheet, 0.1, [0], true);
		},
		update: function() {
			this.parent();
			this.starburstAnim.update();
			this.starburstAnim.angle += ig.system.tick * this.starburstOmega;
		},
		draw: function() {
			var ctx = ig.system.context;
			ctx.save();
			this.starburstAnim.draw(this.pos.x - this.starburstOffset.x, this.pos.y - this.starburstOffset.y);
			this.parent();
			ctx.restore();
		}
	});
});