ig.module(
	'game.misc.background'
).requires(
	'impact.impact'
).defines(function() {
	Rays = ig.Class.extend({
		theta: 0,
		omega: .03,
		numberOfRays: 50,
		pos: {
			x: 0,
			y: 0
		},
		length: 800,
		color: 'rgba(180,180,180,.4)',
		currentThickness: 1,
		growthickness: 7,
		growtime: .5,
		growtimer: null,
		init: function(x, y) {
			this.pos.x = (x) ? x : 0;
			this.pos.y = (y) ? y : 0;
		},
		update: function() {
			this.theta += this.omega * ig.system.tick;
			if (this.growtimer && this.growtimer.delta() >= 0) {
				this.growtimer = null;
				this.currentThickness = 1;
				this.color = 'rgba(180,180,180,.4)';
			} else if (this.growtimer) {
				this.currentThickness = this.growtimer.delta().quadraticEaseOut(-this.growtime, 0, this.growthickness, 1);
				this.color = 'rgba(180,180,180,1)';
			}
		},
		draw: function() {
			var cvs = ig.system.canvas;
			var ctx = ig.system.context;
			ctx.save();
			ctx.beginPath();
			ctx.strokeStyle = this.color;
			ctx.lineWidth = this.currentThickness;
			ctx.translate(this.pos.x, this.pos.y);
			ctx.moveTo(0, 0);
			ctx.rotate(this.theta);
			for (var i = 0; i < this.numberOfRays; i++) {
				ctx.rotate(Math.PI * 2 / this.numberOfRays);
				ctx.lineTo(0, this.length);
				ctx.moveTo(0, 0);
			}
			ctx.stroke();
			ctx.restore();
		},
		pulse: function() {
			if (this.growtimer) {
				this.growtimer.reset();
			} else {
				this.growtimer = new ig.Timer(this.growtime);
			}
			this.currentThickness = this.growthickness;
		}
	});
	Background = ig.Class.extend({
		bottomRay: new Rays(0, 0),
		gradient: new ig.Image('media/acp_bg.png'),
		init: function() {
			this.bottomRay.pos.x = ig.system.width / 5 * 4;
			this.bottomRay.pos.y = ig.system.height * 3 / 2;
		},
		update: function() {
			this.bottomRay.update();
		},
		draw: function() {
			ig.system.context.save();
			this.gradient.draw(0, 0);
			this.bottomRay.draw();
			ig.system.context.restore();
		},
		pulseRays: function() {
			this.bottomRay.pulse();
		}
	});
});