ig.module('game.scenes.adscene').requires('plugins.scene_manager', 'game.buttons.ready', 'impact.entity').defines(function() {
	AdScene = Scene.extend({
		readyButton: null,
		readyTimer: null,
		readyTime: 3,
		blackBackground: null,
		oneTimer: null,
		twoTimer: null,
		init: function() {
			this.parent('ad scene');
		},
		update: function() {
			this.parent();
			if (this.readyTimer && this.readyTimer.delta() >= 0) {
				this.readyButton = ig.game.touchController.addButton(ButtonReady, 60, 300);
				this.readyTimer = null;
			}
			if (ig.input.pressed('ready')) {
				ig.game.sceneManager.replaceScene(new WinScene());
				ig.game.currentLevel++;
			}
			if (this.oneTimer && this.oneTimer.delta() >= 0) {
				ig.game.spawnEntity(EntityFloatingtext, ig.system.width / 2, ig.system.height / 4, {
					string: '2..',
					lifetime: 2
				});
				this.oneTimer = null;
			}
			if (this.twoTimer && this.twoTimer.delta() >= 0) {
				ig.game.spawnEntity(EntityFloatingtext, ig.system.width / 2, ig.system.height / 4, {
					string: '1.',
					lifetime: 2
				});
				this.twoTimer = null;
			}
		},
		onEntry: function() {
			this.readyTimer = new ig.Timer(this.readyTime);
			this.oneTimer = new ig.Timer(1);
			this.twoTimer = new ig.Timer(2);
			if (ig.adHandler) {
				ig.adHandler.unhideAd();
			}
			ig.game.playGrid.clearGrid();
			this.blackBackground = ig.game.spawnEntity(EntityBlackbg, 0, 0);
			ig.game.spawnEntity(EntityFloatingtext, ig.system.width / 2, ig.system.height / 4, {
				string: '3...',
				lifetime: 2
			});
		},
		onExit: function() {
			if (this.readyButton) {
				ig.game.touchController.removeButton(this.readyButton);
				this.readyButton = null;
			}
			if (ig.adHandler) {
				ig.adHandler.hideAd();
			}
			this.blackBackground.kill();
			this.blackBackground = null;
		}
	});
	EntityBlackbg = ig.Entity.extend({
		gravityFactor: 0,
		alpha: 0.6,
		animSheet: new ig.AnimationSheet('media/blackbg.png', 320, 480),
		init: function(x, y, settings) {
			this.parent(x, y, settings);
			this.addAnim('default', 0.1, [0], true);
			this.currentAnim.alpha = this.alpha;
		}
	});
});