ig.module(
	'game.scenes.playingscene'
).requires(
	'plugins.scene_manager',
	'game.misc.level',
	'game.buttons.pausebutton'
).defines(function() {
	PlayingScene = Scene.extend({
		currentNextLevel: 0,
		pauseButton: null,
		init: function() {
			this.parent('playing scene');
		},
		update: function() {
			this.parent();
			if (ig.game.score >= this.currentNextLevel) {
				this.win();
			}
		},
		draw: function() {},
		onEntry: function() {
			ig.game.blockGenerator.startBlockTimer(this.getCurrentSpeed());
			ig.game.playGrid.placeBlocksRandom(this.getCurrentHeight());
			this.currentNextLevel = this.getCurrentNext();
			this.pauseButton = ig.game.touchController.addButton(ButtonPause, ig.system.width - 50, 0);
		},
		onExit: function() {
			ig.game.blockGenerator.stopBlockTimer();
			ig.game.touchController.removeButton(this.pauseButton);
		},
		getCurrentSpeed: function() {
			return ig.game.levels[ig.game.currentLevel].speed;
		},
		getCurrentNext: function() {
			return ig.game.levels[ig.game.currentLevel].next;
		},
		getCurrentHeight: function() {
			return ig.game.levels[ig.game.currentLevel].height;
		},
		win: function() {
			if (ig.ua.mobile && ig.game.currentLevel % 4 == 0) {
				ig.game.sceneManager.pushScene(new AdScene());
			} else {
				ig.game.sceneManager.pushScene(new WinScene());
				ig.game.currentLevel++;
			}
		}
	});
});