ig.module('game.scenes.winscene').requires('plugins.scene_manager').defines(function() {
	WinScene = Scene.extend({
		readyButton: null,
		readytimer: null,
		readytime: 1.6,
		nexttime: 2.4,
		nexttimer: null,
		wintime: 0.8,
		wintimer: null,
		readyString: {
			en: 'Ready?'
		},
		goString: {
			en: 'Go!'
		},
		levelString: {
			en: 'Level '
		},
		init: function() {
			this.parent('win scene');
		},
		update: function() {
			if (this.readytimer && this.readytimer.delta() >= 0) {
					ig.game.spawnEntity(EntityFloatingtext, ig.system.width / 2, ig.system.height / 4, {
						string: this.readyString.en,
						lifetime: 2
					});
				this.readytimer = null;
			}
			if (this.nexttimer && this.nexttimer.delta() >= 0) {
					ig.game.spawnEntity(EntityFloatingtext, ig.system.width / 2, ig.system.height / 4, {
						string: this.goString.en,
						lifetime: 2
					});
				ig.game.sceneManager.popScene();
				this.nexttimer = null;
			}
			if (this.wintimer && this.wintimer.delta() >= 0) {
					ig.game.spawnEntity(EntityFloatingtext, ig.system.width / 2, ig.system.height / 4, {
						string: this.levelString.en + ig.game.currentLevel,
						lifetime: 2
					});
				this.wintimer = null;
			}
			if (ig.input.pressed('ready')) {
				ig.game.sceneManager.popScene();
			}
		},
		draw: function() {},
		onEntry: function() {
			ig.game.playGrid.clearGrid();
			this.readytimer = new ig.Timer(this.readytime);
			this.nexttimer = new ig.Timer(this.nexttime);
			this.wintimer = new ig.Timer(this.wintime);
		},
		onExit: function() {
			ig.game.touchController.removeButton(this.readyButton);
		}
	});
});