﻿ig.module(
	'plugins.screenfader'
).requires(
	'plugins.timeslower'
).defines(function() {
	ScreenFader = ig.Class.extend({
		fadeColor: 'rgb(0,0,0)',
		fadeTime: 1,
		fadeTimer: null,
		fading: false,
		currentAlpha: 0,
		startAlpha: 0,
		endAlpha: 1,
		executeOnEnd: function() {
			return null;
		},
		draw: function() {
			if (this.fading) {
				this.currentAlpha = (this.fadeTimer.delta() + this.fadeTime).map(0, this.fadeTime, this.startAlpha, this.endAlpha);
				if (this.fadeTimer && this.fadeTimer.delta() >= 0) {
					this.currentAlpha = this.endAlpha;
					this.fading = false;
					this.fadeTimer = null;
					this.executeOnEnd();
				}
				var context = ig.system.context;
				var canvas = ig.system.canvas;
				var tempAlpha = context.globalAlpha;
				context.fillStyle = this.fadeColor;
				context.globalAlpha = this.currentAlpha;
				context.globalAlpha = this.currentAlpha;
				context.fillRect(0, 0, canvas.width, canvas.height);
				context.globalAlpha = tempAlpha;
			}
		},
		fadeBegin: function(color, time, startAlpha, endAlpha, executeOnEnd) {
			if (!this.fading) {
				this.fadeColor = (color) ? color : this.fadeColor;
				this.fadeTime = (time) ? time : this.fadeTime;
				this.startAlpha = (startAlpha || startAlpha == 0) ? startAlpha : 0;
				this.endAlpha = (endAlpha || endAlpha == 0) ? endAlpha : 1;
				this.executeOnEnd = (executeOnEnd) ? executeOnEnd : function() {
					return null;
				};
				this.fading = true;
				this.fadeTimer = new Supertimer(this.fadeTime);
			} else {
				ig.log("plugin.screenfader.fadeBegin() called while already fading.");
			}
		}
	});
});