﻿ig.module(
	'plugins.timeslower'
).requires(
	'impact.impact'
).defines(function() {
	Supertimer = ig.Class.extend({
		target: 0,
		base: 0,
		last: 0,
		init: function(seconds) {
			this.base = Supertimer.time;
			this.last = Supertimer.time;
			this.target = seconds || 0;
		},
		set: function(seconds) {
			this.target = seconds || 0;
			this.base = Supertimer.time;
		},
		reset: function() {
			this.base = Supertimer.time;
		},
		tick: function() {
			var delta = Supertimer.time - this.last;
			this.last = Supertimer.time;
			return delta;
		},
		delta: function() {
			return Supertimer.time - this.base - this.target;
		}
	});
	Supertimer._last = 0;
	Supertimer.time = 0;
	Supertimer.maxStep = 0.05;
	Supertimer.step = function() {
		var current = Date.now();
		var delta = (current - Supertimer._last) / 1000;
		Supertimer.time += Math.min(delta, Supertimer.maxStep);
		Supertimer._last = current;
	};
	ig.System.inject({
		run: function() {
			ig.Timer.step();
			Supertimer.step();
			this.tick = this.clock.tick();
			this.delegate.run();
			ig.input.clearPressed();
			if (this.newGameClass) {
				this.setGameNow(this.newGameClass);
				this.newGameClass = null;
			}
		},
	});
	TimeSlower = ig.Class.extend({
		currentTimeScale: 1,
		timeScaleHolder: 1,
		changedTimer: null,
		changedTime: 0,
		constantDuration: 0,
		slowingDownDuration: 0,
		returnToNormalDuration: 0,
		slowingDown: false,
		constant: false,
		returningToNormal: false,
		segmentStartValue: 0,
		segmentEndValue: 0,
		update: function() {
			if (this.changedTimer && this.changedTimer.delta() >= 0) {
				ig.Timer.timeScale = this.changedTimer.delta().map(0, this.changedTime, this.segmentStartValue, this.segmentEndValue);
				if (this.changedTimer.delta() >= this.returnToNormalTime) {
					this.changedTimer = null;
					ig.Timer.timeScale = 1;
					ig.log("timescale back to 1");
				}
			}
		},
		alterTimeScale: function(timescale, slowingDownDuration, constantDuration, returnToNormalDuration) {
			if (ig.Timer.timeScale == 1) {
				this.timeScaleHolder = timescale;
				this.slowingDownDuration = slowingDownDuration;
				this.constantDuration = constantDuration;
				this.returnToNormalDuration = returnToNormalDuration;
				this.changedTime = slowingDownDuration;
				this.changedTimer = new Supertimer(slowingDownDuration);
				this.slowingDown == true;
			}
		}
	});
});